#ifndef __ENUMS_H__
#define __ENUMS_H__

#include "one_include_to_rule_them_all.h"
#include "defines.h"

typedef enum ENUM_CTRL_IDENTIFIER_N
{
   ID_NULL = 0,
   
   ID_CACHE_DEBUG_TEXT = 1000,

   ID_DLGBOX_COF_IN_P_ICON,
   ID_DLGBOX_COF_IN_P_LABEL,
   ID_DLGBOX_COF_IN_P_PBAR,
   ID_DLGBOX_COF_IN_P_NBFILES,
   ID_DLGBOX_COF_IN_P_EXISTS_L,
   ID_DLGBOX_COF_IN_P_EXISTS_R,
   ID_DLGBOX_COF_IN_P_OK,

   ID_DLGBOX_SETUP_TAB,
   ID_DLGBOX_SETUP_OK,
   ID_DLGBOX_SETUP_CANCEL,

   ID_DLGBOX_SETUP_TABMPQ_LABEL_PATCH_D2,
   ID_DLGBOX_SETUP_TABMPQ_EDIT_PATCH_D2,
   ID_DLGBOX_SETUP_TABMPQ_BUTN_PATCH_D2,
   ID_DLGBOX_SETUP_TABMPQ_LABEL_D2EXP,
   ID_DLGBOX_SETUP_TABMPQ_EDIT_D2EXP,
   ID_DLGBOX_SETUP_TABMPQ_BUTN_D2EXP,
   ID_DLGBOX_SETUP_TABMPQ_LABEL_D2DATA,
   ID_DLGBOX_SETUP_TABMPQ_EDIT_D2DATA,
   ID_DLGBOX_SETUP_TABMPQ_BUTN_D2DATA,
   ID_DLGBOX_SETUP_TABMPQ_LABEL_D2CHAR,
   ID_DLGBOX_SETUP_TABMPQ_EDIT_D2CHAR,
   ID_DLGBOX_SETUP_TABMPQ_BUTN_D2CHAR,

   ID_DLGBOX_SETUP_TABMODDIR_LABEL,
   ID_DLGBOX_SETUP_TABMODDIR_EDIT,
   ID_DLGBOX_SETUP_TABMODDIR_BUTN,

   ID_DLGBOX_MAIN_APP_TIMER,
   ID_DLGBOX_MAIN_ANIMATION,

   ID_DLGBOX_MAIN_COFSEL_GROUP,
   ID_DLGBOX_MAIN_ANIMTYPE_LABEL,
   ID_DLGBOX_MAIN_ANIMTYPE_LIST,
   ID_DLGBOX_MAIN_TOKEN_LABEL,
   ID_DLGBOX_MAIN_TOKEN_LIST,
   ID_DLGBOX_MAIN_WEAPCLASS_LABEL,
   ID_DLGBOX_MAIN_WEAPCLASS_LIST,
   ID_DLGBOX_MAIN_MODES_LABEL,
   ID_DLGBOX_MAIN_MODES_LIST,

   ID_DLGBOX_MAIN_BUT_DIR_MINUS,
   ID_DLGBOX_MAIN_BUT_DIR_PLUS,
   ID_DLGBOX_MAIN_NB_ANIM_COLORS,

   ID_DLGBOX_MAIN_LAYER_GROUP,
   ID_DLGBOX_MAIN_CODE_LABEL,
   ID_DLGBOX_MAIN_VARIANT_LABEL,
   ID_DLGBOX_MAIN_CMAPTYPE_LABEL,
   ID_DLGBOX_MAIN_CMAPFILE_LABEL,
   ID_DLGBOX_MAIN_CMAPINDEX_LABEL,
   ID_DLGBOX_MAIN_GFXTYPE_LABEL,
   ID_DLGBOX_MAIN_GFXLEVEL_LABEL,

   ID_DLGBOX_MAIN_CODE_BASE,
   ID_DLGBOX_MAIN_VARIANT_BASE,
   ID_DLGBOX_MAIN_CMAPTYPE_BASE,
   ID_DLGBOX_MAIN_CMAPFILE_BASE,
   ID_DLGBOX_MAIN_CMAPINDEX_BASE,
   ID_DLGBOX_MAIN_GFXTYPE_BASE,
   ID_DLGBOX_MAIN_GFXLEVEL_BASE,

   ID_RESERVED_01 = ID_DLGBOX_MAIN_CODE_BASE + (16 * DLGBOX_MAIN_CTRL_PER_ROW),

   ID_DLGBOX_EXPORT_FILES_GROUP,
   ID_DLGBOX_EXPORT_DIRECTORY_LABEL,
   ID_DLGBOX_EXPORT_FILEFORMAT_LABEL,
   ID_DLGBOX_EXPORT_FILESAMPLE_LABEL,
   ID_DLGBOX_EXPORT_DIRECTORY_EDIT,
   ID_DLGBOX_EXPORT_DIRECTORY_BUTN,
   ID_DLGBOX_EXPORT_FILEFORMAT_COMBO,
   ID_DLGBOX_EXPORT_FILESAMPLE_EDIT,

   ID_DLGBOX_EXPORT_FORMAT_GROUP,
   ID_DLGBOX_EXPORT_FORMAT_BMP,
   ID_DLGBOX_EXPORT_FORMAT_PCX,
   ID_DLGBOX_EXPORT_FORMAT_PNG,
   ID_DLGBOX_EXPORT_FORMAT_TGA,
   ID_DLGBOX_EXPORT_FORMAT_BAM,

   ID_DLGBOX_EXPORT_IMAGES_GROUP,
   ID_DLGBOX_EXPORT_DIRECTIONS_LABEL,
   ID_DLGBOX_EXPORT_DIRECTIONS_EDIT,
   ID_DLGBOX_EXPORT_DIRECTIONS_BUTN,
   ID_DLGBOX_EXPORT_FRAMES_LABEL,
   ID_DLGBOX_EXPORT_FRAMES_EDIT,
   ID_DLGBOX_EXPORT_FRAMES_BUTN,

   ID_DLGBOX_EXPORT_PALETTE_GROUP,
   ID_DLGBOX_EXPORT_BACKGROUND_LABEL,
   ID_DLGBOX_EXPORT_SHADOW_LABEL,
   ID_DLGBOX_EXPORT_INDEX_LABEL,
   ID_DLGBOX_EXPORT_RED_LABEL,
   ID_DLGBOX_EXPORT_GREEN_LABEL,
   ID_DLGBOX_EXPORT_BLUE_LABEL,
   ID_DLGBOX_EXPORT_BGINDEX_EDIT,
   ID_DLGBOX_EXPORT_BGRED_EDIT,
   ID_DLGBOX_EXPORT_BGGREEN_EDIT,
   ID_DLGBOX_EXPORT_BGBLUE_EDIT,
   ID_DLGBOX_EXPORT_SHINDEX_EDIT,
   ID_DLGBOX_EXPORT_SHRED_EDIT,
   ID_DLGBOX_EXPORT_SHGREEN_EDIT,
   ID_DLGBOX_EXPORT_SHBLUE_EDIT,

   ID_DLGBOX_EXPORT_USER_BOX_GROUP,
   ID_DLGBOX_EXPORT_USER_LEFT_LABEL,
   ID_DLGBOX_EXPORT_USER_TOP_LABEL,
   ID_DLGBOX_EXPORT_USER_RIGHT_LABEL,
   ID_DLGBOX_EXPORT_USER_BOTTOM_LABEL,
   ID_DLGBOX_EXPORT_USER_WIDTH_LABEL,
   ID_DLGBOX_EXPORT_USER_HEIGHT_LABEL,
   ID_DLGBOX_EXPORT_USER_LEFT_EDIT,
   ID_DLGBOX_EXPORT_USER_TOP_EDIT,
   ID_DLGBOX_EXPORT_USER_RIGHT_EDIT,
   ID_DLGBOX_EXPORT_USER_BOTTOM_EDIT,
   ID_DLGBOX_EXPORT_USER_WIDTH_EDIT,
   ID_DLGBOX_EXPORT_USER_HEIGHT_EDIT,

   ID_DLGBOX_EXPORT_ANIM_BOX_GROUP,
   ID_DLGBOX_EXPORT_ANIM_LEFT_LABEL,
   ID_DLGBOX_EXPORT_ANIM_TOP_LABEL,
   ID_DLGBOX_EXPORT_ANIM_RIGHT_LABEL,
   ID_DLGBOX_EXPORT_ANIM_BOTTOM_LABEL,
   ID_DLGBOX_EXPORT_ANIM_WIDTH_LABEL,
   ID_DLGBOX_EXPORT_ANIM_HEIGHT_LABEL,
   ID_DLGBOX_EXPORT_ANIM_LEFT_EDIT,
   ID_DLGBOX_EXPORT_ANIM_TOP_EDIT,
   ID_DLGBOX_EXPORT_ANIM_RIGHT_EDIT,
   ID_DLGBOX_EXPORT_ANIM_BOTTOM_EDIT,
   ID_DLGBOX_EXPORT_ANIM_WIDTH_EDIT,
   ID_DLGBOX_EXPORT_ANIM_HEIGHT_EDIT,

   ID_DLGBOX_EXPORT_PREVIEW_IMG,

   ID_DLGBOX_EXPORT_SHADOW_GROUP,
   ID_DLGBOX_EXPORT_SH_H_LABEL,
   ID_DLGBOX_EXPORT_SH_H_EDIT,
   ID_DLGBOX_EXPORT_SH_H_PNCT_LABEL,
   ID_DLGBOX_EXPORT_SH_H_TRACKBAR,
   ID_DLGBOX_EXPORT_SH_S_LABEL,
   ID_DLGBOX_EXPORT_SH_S_EDIT,
   ID_DLGBOX_EXPORT_SH_S_PNCT_LABEL,
   ID_DLGBOX_EXPORT_SH_S_TRACKBAR,
   ID_DLGBOX_EXPORT_SH_OFX_LABEL,
   ID_DLGBOX_EXPORT_SH_OFX_EDIT,
   ID_DLGBOX_EXPORT_SH_OFY_LABEL,
   ID_DLGBOX_EXPORT_SH_OFY_EDIT,
   ID_DLGBOX_EXPORT_UP_BUTN,
   ID_DLGBOX_EXPORT_DOWN_BUTN,
   ID_DLGBOX_EXPORT_LEFT_BUTN,
   ID_DLGBOX_EXPORT_RIGHT_BUTN,

   ID_DLGBOX_EXPORT_USING_BOX_GROUP,
   ID_DLGBOX_EXPORT_USING_BOX_USER,
   ID_DLGBOX_EXPORT_USING_BOX_ANIM,

   ID_DLGBOX_EXPORT_MIRROR_GROUP,
   ID_DLGBOX_EXPORT_MIRROR_ANIMATION,

   ID_DLGBOX_EXPORT_VAR_LIST,

   ID_DLGBOX_EXPORT_EXPORT_BUTN,
   ID_DLGBOX_EXPORT_CLOSE_BUTN,

   ID_MENU_MAIN_EXPORT,
   ID_MENU_MAIN_EXPORT_ACCEL,
   ID_MENU_MAIN_OPTIONS,
   ID_MENU_MAIN_EXIT,
   ID_MENU_MAIN_COPY,
   ID_MENU_MAIN_WINDOWCACHE,
   ID_MENU_MAIN_ABOUT,

   ID_MAX
} ENUM_CTRL_IDENTIFIER;

typedef enum ENUM_MY_FONT_N
{
   FONT_NONE            = -1,
   FONT_VERDANA_12      = 0,
   FONT_VERDANA_13      = 1,
   FONT_VERDANA_13_BOLD = 2,
   FONT_VERDANA_14      = 3,
   FONT_VERDANA_14_BOLD = 4,
   FONT_CONSOLAS_14     = 5,
   FONT_CONSOLAS_15     = 6,
   FONT_MAX             = 7
} ENUM_MY_FONT;

typedef enum ENUM_MPQ_N
{
   MPQ_DEFAULT_D2_FILES = -1, // don't need all the MPQ or Mod Directory datas, hence the special negative value
   MPQ_MOD_DIRECTORY    = 0,
   MPQ_PATCH_D2         = 1,
   MPQ_D2EXP            = 2,
   MPQ_D2DATA           = 3,
   MPQ_D2CHAR           = 4,
   MPQ_MAX              = 5
} ENUM_MPQ;

typedef enum ENUM_ANIMTYPE_N
{
   AT_NULL     = -1,
   AT_PLAYERS  = 0,
   AT_MONSTERS = 1,
   AT_OBJECTS  = 2,
   AT_MAX      = 3
} ENUM_ANIMTYPE;

typedef enum ENUM_COFSELTYPE_N
{
   CST_NONE      = -1,
   CST_ANIMTYPE  = 0,
   CST_TOKEN     = 1,
   CST_WEAPCLASS = 2,
   CST_MODES     = 3,
   CST_MAX       = 4
} ENUM_COFSELTYPE;

typedef enum ENUM_WINDOW_TYPE_N
{
   WT_MAIN        = 0,
   WT_CACHE_DEBUG = 1,
   WT_MAX         = 2
} ENUM_WINDOW_TYPE;

typedef enum ENUM_D2_RESSOURCES_TYPE_N
{
   D2RT_NULL        = 0,
   D2RT_TEXT        = 1,
   D2RT_PALETTE     = 2,
   D2RT_ANIMDATA_D2 = 3,
   D2RT_MAX         = 4
} ENUM_D2_RESSOURCES_TYPE;

typedef enum ENUM_D2_RESSOURCES_N
{
   D2R_NONE        = -1,
   D2R_COMPOSIT    =  0,
   D2R_WEAPONCLASS =  1,
   D2R_PLRTYPE     =  2,
   D2R_PLRMODE     =  3,
   D2R_OBJMODE     =  4,
   D2R_COLORS      =  5,
   D2R_MONSTATS    =  6,
   D2R_OBJECTS     =  7,
   D2R_ACT1PAL     =  8,
   D2R_ACT2PAL     =  9,
   D2R_ACT3PAL     = 10,
   D2R_ACT4PAL     = 11,
   D2R_ACT5PAL     = 12,
   D2R_ANIMDATA_D2 = 13,
   D2R_MAX         = 14
} ENUM_D2_RESSOURCES;

typedef enum ENUM_ROW_EXTENSION_N
{
   REXT_NULL = -1,
   REXT_COF  = 0,
   REXT_DCC  = 1,
   REXT_DC6  = 2,
   REXT_MAX  = 3
} ENUM_ROW_EXTENSION;

typedef enum DLGBOX_MODAL_TYPE_N
{
   DLGMT_MODLESS = 0,
   DLGMT_MODAL   = 1
} DLGBOX_MODAL_TYPE;

typedef enum ENUM_DLGBOX_ID_N
{
   DLG_NONE             = -1,
   DLG_COF_IN_PROGRESS  = 0,
   DLG_SETUP_TAB_MPQ    = 1,
   DLG_SETUP_TAB_MODDIR = 2,
   DLG_SETUP_TAB_CACHE  = 3,
   DLG_SETUP            = 4, // in order for IsDialogMessage() to work best [in WinMain()], we have to order the dialogs enumeration from children to parent (but why ?)
   DLG_EXPORT           = 5,
   DLG_MAIN             = 6,
   DLG_MAX              = 7
} ENUM_DLGBOX_ID;

typedef enum ENUM_EXPORT_DATA_STATE_N
{
   EDS_TO_INITIALIZE = 0,
   EDS_JUST_LOADED   = 1,
   EDS_ALL_READY     = 2,
   EDS_MAX           = 3
} ENUM_EXPORT_DATA_STATE;

typedef enum ENUM_VAR_LIST_N
{
   VL_COF =  0,
   VL_TOK =  1,
   VL_MOD =  2,
   VL_WPC =  3,
   VL_DIR =  4,
   VL_FRM =  5,
   VL_IMG =  6,
   VL_DID =  7,
   VL_FID =  8,
   VL_IID =  9,
   VL_VAR = 10,
   VL_VHD = 11,
   VL_VTR = 12,
   VL_VLG = 13,
   VL_VRA = 14,
   VL_VLA = 15,
   VL_VRH = 16,
   VL_VLH = 17,
   VL_VSH = 18,
   VL_VS1 = 19,
   VL_VS2 = 20,
   VL_VS3 = 21,
   VL_VS4 = 22,
   VL_VS5 = 23,
   VL_VS6 = 24,
   VL_VS7 = 25,
   VL_VS8 = 26,
   VL_MAX = 27
} ENUM_VAR_LIST;

#endif
